# 
#              This file is part of the New World OS project
#                     Copyright (C) 2007 QRW Software
#            J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
#                       http://www.qrwsoftware.com
#                       http://nwos.sourceforge.com
# 
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
# 
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
# 
#    You should have received a copy of the GNU General Public License
#    along with this program, in the file LICENSE.  If not, see 
#    <http://www.gnu.org/licenses/>.
# 
#    You can also contact me via paper mail at:
# 
#       QRW Software
#       P.O. Box 27511
#       Salt Lake City, UT 84127-0511, USA.
# 
# 
#  This script runs various tests on the remove_file program.
# 
#  $Log: remove_file_test.sh,v $
#  Revision 1.4  2007/09/16 14:58:09  jsedwards
#  Added test cases for the last scenario that was untested (entry to be
#  removed was in first block, but there are two or more blocks).
#
#  Revision 1.3  2007/09/16 04:06:28  jsedwards
#  Added tests that span multiple blocks.
#
#  Revision 1.2  2007/09/15 20:57:42  jsedwards
#  Commented out the ones that failed because remove_from_reference_list can't
#  handle that case yet and added more tests for second and third blocks.
#
#  Revision 1.1  2007/09/15 15:53:28  jsedwards
#  Initial version, tests remove file with one and two blocks in reference_list.
#
# 

./test_remove.sh 3 file0001.txt
./test_remove.sh 3 file0002.txt
./test_remove.sh 3 file0003.txt

./test_remove.sh 53 file0050.txt
./test_remove.sh 53 file0053.txt

./test_remove.sh 54 file0004.txt
./test_remove.sh 54 file0054.txt

./test_remove.sh 55 file0005.txt
./test_remove.sh 55 file0053.txt
./test_remove.sh 55 file0054.txt
./test_remove.sh 55 file0055.txt

./test_remove.sh 56 file0006.txt
./test_remove.sh 56 file0053.txt
./test_remove.sh 56 file0054.txt
./test_remove.sh 56 file0055.txt
./test_remove.sh 56 file0056.txt


./test_remove.sh 113 file0007.txt
./test_remove.sh 113 file0053.txt
./test_remove.sh 113 file0054.txt
./test_remove.sh 113 file0055.txt
./test_remove.sh 113 file0056.txt
./test_remove.sh 113 file0112.txt
./test_remove.sh 113 file0113.txt

./test_remove.sh 114 file0008.txt
./test_remove.sh 114 file0053.txt
./test_remove.sh 114 file0054.txt
./test_remove.sh 114 file0055.txt
./test_remove.sh 114 file0056.txt
./test_remove.sh 114 file0112.txt
./test_remove.sh 114 file0113.txt
./test_remove.sh 114 file0114.txt

./test_remove.sh 115 file0009.txt
./test_remove.sh 115 file0053.txt
./test_remove.sh 115 file0054.txt
./test_remove.sh 115 file0055.txt
./test_remove.sh 115 file0056.txt
./test_remove.sh 115 file0112.txt
./test_remove.sh 115 file0113.txt
./test_remove.sh 115 file0114.txt
./test_remove.sh 115 file0115.txt

./test_remove.sh 116 file0010.txt
./test_remove.sh 116 file0053.txt
./test_remove.sh 116 file0054.txt
./test_remove.sh 116 file0055.txt
./test_remove.sh 116 file0056.txt
./test_remove.sh 116 file0113.txt
./test_remove.sh 116 file0114.txt
./test_remove.sh 116 file0115.txt
./test_remove.sh 116 file0116.txt

./test_remove.sh 172 file0011.txt
./test_remove.sh 172 file0053.txt
./test_remove.sh 172 file0054.txt
./test_remove.sh 172 file0055.txt
./test_remove.sh 172 file0056.txt
./test_remove.sh 172 file0113.txt
./test_remove.sh 172 file0114.txt
./test_remove.sh 172 file0115.txt
./test_remove.sh 172 file0116.txt
./test_remove.sh 172 file0171.txt
./test_remove.sh 172 file0172.txt

./test_remove.sh 173 file0012.txt
./test_remove.sh 173 file0053.txt
./test_remove.sh 173 file0054.txt
./test_remove.sh 173 file0055.txt
./test_remove.sh 173 file0056.txt
./test_remove.sh 173 file0113.txt
./test_remove.sh 173 file0114.txt
./test_remove.sh 173 file0115.txt
./test_remove.sh 173 file0116.txt
./test_remove.sh 173 file0172.txt
./test_remove.sh 173 file0173.txt

./test_remove.sh 174 file0013.txt
./test_remove.sh 174 file0053.txt
./test_remove.sh 174 file0054.txt
./test_remove.sh 174 file0055.txt
./test_remove.sh 174 file0056.txt
./test_remove.sh 174 file0113.txt
./test_remove.sh 174 file0114.txt
./test_remove.sh 174 file0115.txt
./test_remove.sh 174 file0116.txt
./test_remove.sh 174 file0172.txt
./test_remove.sh 174 file0173.txt
./test_remove.sh 174 file0174.txt

./test_remove.sh 175 file0014.txt
./test_remove.sh 175 file0053.txt
./test_remove.sh 175 file0054.txt
./test_remove.sh 175 file0055.txt
./test_remove.sh 175 file0056.txt
./test_remove.sh 175 file0113.txt
./test_remove.sh 175 file0114.txt
./test_remove.sh 175 file0115.txt
./test_remove.sh 175 file0116.txt
./test_remove.sh 175 file0172.txt
./test_remove.sh 175 file0173.txt
./test_remove.sh 175 file0174.txt
./test_remove.sh 175 file0175.txt

./test_remove.sh 176 file0015.txt
./test_remove.sh 176 file0053.txt
./test_remove.sh 176 file0054.txt
./test_remove.sh 176 file0055.txt
./test_remove.sh 176 file0056.txt
./test_remove.sh 176 file0113.txt
./test_remove.sh 176 file0114.txt
./test_remove.sh 176 file0115.txt
./test_remove.sh 176 file0116.txt
./test_remove.sh 176 file0172.txt
./test_remove.sh 176 file0173.txt
./test_remove.sh 176 file0174.txt
./test_remove.sh 176 file0175.txt
./test_remove.sh 176 file0176.txt

