--
--             This file is part of the New World OS project
--                 Copyright (C) 2006-2007  QRW Software
--           J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--                      http://www.qrwsoftware.com
--                      http://nwos.sourceforge.com
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
--
-- $Log: nwos_consonant.e,v $
-- Revision 1.2  2007/07/01 19:44:13  jsedwards
-- Upgrade to GPLv3.
--
-- Revision 1.1  2007/04/14 02:24:13  jsedwards
-- Move Fine (Eiffel) files to next_gen directory.
--
-- Revision 1.10  2006/11/11 12:29:19  jsedwards
-- Update e-mail address to something that works.
--
-- Revision 1.9  2006/02/13 04:28:58  jsedwards
-- Changed "make" feature in letter to "make_with_alphabet", because "make"
-- no longer has a parameter.
--
-- Revision 1.8  2006/02/10 13:55:34  jsedwards
-- Changed "load" in creation clause to "make_unresolved".
--
-- Revision 1.7  2006/02/09 12:51:27  jsedwards
-- Changed to the new method of doing the class defintion stuff, with the
-- "class reference" and "class revision".
--
-- Revision 1.6  2006/02/08 14:21:10  jsedwards
-- Added "load" to creation clause and predefined reference to class
-- definition "make" call.
--
-- Revision 1.5  2006/02/05 04:38:50  jsedwards
-- Change to new deferred class definition format.
--
-- Revision 1.4  2006/02/02 02:18:26  jsedwards
-- Removed class ref (old method of getting class reference) and changed
-- class name so that it can be changed by vowel or consonant class.
--
-- Revision 1.3  2006/01/31 14:23:09  jsedwards
-- Added new class defintion klugde.
--
-- Revision 1.2  2006/01/30 05:00:35  jsedwards
-- Moved sounds out of "vowel" and "consonant" classes and into "letter" to
-- avoid grief from multiple repeated inheritence.
--
-- Revision 1.1  2006/01/29 19:57:47  jsedwards
-- Initial version, untested!
--


class NWOS_CONSONANT

inherit NWOS_LETTER

creation make_with_alphabet, make_unresolved


feature {NONE}  -- once again the kludgy class definition stuff

   class_revision: STRING is
      once
         !!Result.copy("$Revision: 1.2 $")
         Result.remove_prefix("$Revision: ")
         Result.remove_suffix(" $")
      end

   class_reference: NWOS_REFERENCE is
      do
         Result := Class_consonant_ref
      end

end

