--
--             This file is part of the New World OS project
--                 Copyright (C) 2006-2007  QRW Software
--           J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--                      http://www.qrwsoftware.com
--                      http://nwos.sourceforge.com
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
--
-- $Log: nwos_session.e,v $
-- Revision 1.2  2007/07/01 19:44:14  jsedwards
-- Upgrade to GPLv3.
--
-- Revision 1.1  2007/04/14 02:24:18  jsedwards
-- Move Fine (Eiffel) files to next_gen directory.
--
-- Revision 1.4  2006/11/11 12:29:19  jsedwards
-- Update e-mail address to something that works.
--
-- Revision 1.3  2006/02/16 03:00:52  jsedwards
-- Removed the "current_source_file" feature.  The source file is passed
-- directly to the spelling in big_bang.
--
-- Revision 1.2  2006/02/15 14:27:46  jsedwards
-- Added "current_source_file" to pass the source file being worked on to
-- spelling.
--
-- Revision 1.1  2006/02/10 02:13:08  jsedwards
-- Class that can be inherited by both the application and the header so that
-- the application can setup the session log and grade and the header can
-- access that information.
--


class NWOS_SESSION

feature

   session_log: NWOS_SESSION_LOG is
      once
         !!Result.make
      end

   session_grade: NWOS_OBJECT_GRADE is
      once
         !!Result.make("Base object created in the original Big Bang.")
      end

end

