--
--             This file is part of the New World OS project
--                 Copyright (C) 2006-2007  QRW Software
--           J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--                      http://www.qrwsoftware.com
--                      http://nwos.sourceforge.com
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
--
-- $Log: nwos_thing.e,v $
-- Revision 1.2  2007/07/01 19:44:14  jsedwards
-- Upgrade to GPLv3.
--
-- Revision 1.1  2007/04/14 02:24:22  jsedwards
-- Move Fine (Eiffel) files to next_gen directory.
--
-- Revision 1.2  2006/11/11 12:29:19  jsedwards
-- Update e-mail address to something that works.
--
-- Revision 1.1  2006/02/26 15:46:10  jsedwards
-- Incomplete version, not used.
--

class NWOS_THING

-- This class represents an abstract "thing" such as a word or a car.
-- It represents that "thing" in any language.

inherit NWOS_OBJECT

feature

   names: ARRAY[NWOS_NOUN] is
      do
         load_if_not_already
         Result := names_obj
      ensure
         Result /= Void
      end

   add_name(noun: NWOS_NOUN) is
      do
         names.add_last(noun)
      end


feature {NONE}

   write_names_to_stream(stream: BINARY_OUTPUT_STREAM) is
      local
         i: INTEGER
      do
         from
            i := names_obj.lower
         variant
            names_obj.upper - i
         until
            i > names_obj.upper
         loop
            names_obj.item(i).class_definition.identifier.write_to_stream(stream)
            names_obj.item(i).identifier.write_to_stream(stream)
            i := i + 1
         end
      end

   read_names_from_stream(stream: BINARY_INPUT_STREAM): NWOS_REFERENCE is
      local
         noun: NWOS_NOUN
         object_ref: NWOS_REFERENCE
      do
         !!names_obj.with_capacity(4, 1)

         from
            !!Result.make_from_stream(stream)
         until
            not Result.is_equal(Class_noun_ref)
         loop
            !!object_ref.make_from_stream(stream)

            noun ?= object_ref.get_object(Result)

            check
               noun /= Void
            end

            names_obj.add_last(noun)

            !!Result.make_from_stream(stream)
         end
      end


feature {NONE}

   names_obj: like names


end

